#-----------------------------------------------------------------------------
%{?!dist:	%define	dist	.ok}
%define		sname	%(echo %{name} | cut -d '-' -f2)
#-----------------------------------------------------------------------------
Name		:	rust-bindgen
Version		:	0.69.4
Release		:	16.2.0.rel%{?dist}
Summary		:	Automatically generates Rust FFI bindings to C and C++ libraries

Packager	:	Osukiss Project	<build-ok@osukiss.org>

License		:	BSD-3-Clause
URL		:	https://crates.io/crates/bindgen
			#https://github.com/rust-lang/rust-bindgen/

Source0		:	%{name}-%{version}.tar.gz

#-----------------------------------------------------------------------------
BuildRequires	:	cargo
BuildRequires	:	rustc

#-----------------------------------------------------------------------------
%description
Automatically generates Rust FFI bindings to C and C++ libraries

#-----------------------------------------------------------------------------
%files			
%defattr(-,root,root,-)
%doc README.md
%license LICENSE
%{_bindir}/%{sname}
%{_datadir}/bash-completion/completions/%{sname}
%{_datadir}/fish/vendor_completions.d/%{sname}.fish
%{_datadir}/zsh/site-functions/_%{sname}

#=============================================================================
%prep
%setup -q

cargo fetch --locked --target "$(rustc -vV | sed -n 's/host: //p')"

%{__mkdir_p}	completions

#-----------------------------------------------------------------------------
#building application
%build
%define _smp_mflags -j%(/usr/bin/getconf _NPROCESSORS_ONLN)
cargo build 						\
	%{_smp_mflags}					\
	--release					\
	--frozen					\

target/release/bindgen					\
	--generate-shell-completions			\
	bash  > completions/%{sname}

target/release/bindgen					\
	--generate-shell-completions			\
	fish  > completions/%{sname}.fish

target/release/bindgen					\
	--generate-shell-completions			\
	zsh  > completions/_%{sname}

#-----------------------------------------------------------------------------
%clean
%{__rm} -rf %{buildroot}

#-----------------------------------------------------------------------------
#installing program
%install
%{__rm} -rf %{buildroot}

install -D -m755					\
	target/release/bindgen				\
	%{buildroot}%{_bindir}/bindgen

install -D -m655					\
	completions/bindgen				\
	-t %{buildroot}%{_datadir}/bash-completion/completions/

install -D -m655					\
	completions/bindgen.fish			\
	-t %{buildroot}%{_datadir}/fish/vendor_completions.d

install -D -m655					\
	completions/_bindgen				\
	-t %{buildroot}%{_datadir}/zsh/site-functions/

#-----------------------------------------------------------------------------
%changelog
